#!/usr/bin/perl

$decision = $ARGV[0];
if (! ($decision eq "nautilus" ||
       $decision eq "gmc")) {
    $decision = "none";
}
$section = "";

$inputf = "$ENV{'HOME'}/.gnome/session";
if (! -f $inputf) {
  $inputf = "/usr/share/gnome/default.session";
}
$outputf = "/tmp/arrghh";

$last = -1;


my $needs_to_add;
my @needs_to_remove;
my %remove_keys;

if ($decision eq "nautilus") {
    push @needs_to_remove, "gmc";
}

if ($decision eq "gmc") {
    push @needs_to_remove, "nautilus";
}

if ($decision eq "none") {
    push @needs_to_remove, "gmc";
    push @needs_to_remove, "nautilus";
}
    
$needs_to_add = $decision;

my $session_exists;

$count = 0;

if (open SESSION, $inputf) {
    $session_exists = 1;
    while ($line = <SESSION>) {
	if ($line =~ /\[(.*)\]/) {
	    $section = $1;
	} else {
	    if ($section eq "Default") {
		if ($line =~ /^num_clients=([0-9]*)/) {
		    $count = $1;
		    last;
		} else {
		    $line =~ /([0-9]+),(.*)/;
		    $which = $1;
		    $data = $2;
		    if ($data =~ /RestartCommand=(.*)/) {
			$cmd = (split (/\s/, $1))[0];
			foreach (@needs_to_remove) {
			    if ($cmd eq $_) {
				$remove_keys{$which} = $which;
			    }
			}
			if (!($needs_to_add eq "none") and ($cmd eq $needs_to_add)) {
			    push @needs_to_remove, $needs_to_add;
			    $needs_to_add = "none";
			}
		    }
		}
	    }
	}
    }
} else {
    $session_exists = 0;
}

$decrease = 0;
%already_done;

$need_resume = 0;

if ($session_exists) {
    # Remove the necessary thingys
    open SESSION, $inputf;
    open OUTPUT, "> $outputf";

    while ($line = <SESSION>) {
	if ($line =~ /\[(.*)\]/) {
	    $section = $1;
	} else {
	    if ($section eq "Default") {
		if ($line =~ /^num_clients=/) {
		    $line = "";
		    print "breaking\n";
		    last;
		} else {
		    if ($line =~ /^(\d*),/) {
			$num = $1;
			if ($remove_keys{$num} eq $num) {
			    $line = "";
			    if ($already_done{$num} != 1) {
				$decrease = $decrease + 1;
			    }
			    $already_done{$num} = 1;
			}
		    }
		}
	    }
	}

	if ($line =~ /^(\d*),(.*)/) {
	    $num = $1 - $decrease;
	    $line = "$num,$2\n";
	}

	if (!($line eq "")) {
	    print OUTPUT $line;
	    $line = "";
	}

    }
    $need_resume = 1;
} else {
    open OUTPUT, "> $outputf";
    print OUTPUT "[Default]\n";
}

foreach (keys %remove_keys) {
    $count--;
}

if (!($needs_to_add eq "none")) {
    $count++;
}

$last = $count - 1;
if (!($needs_to_add eq "none")) {
    print OUTPUT <<EOF;
$last,RestartStyleHint=2
$last,Priority=40
$last,Program=$needs_to_add
$last,CurrentDirectory=$ENV{"HOME"}
$last,CloneCommand=$needs_to_add
EOF

    if ($needs_to_add eq "gmc") {
        print OUTPUT "$last,RestartCommand=gmc --nowindows\n"
    } else  {
        print OUTPUT "$last,RestartCommand=nautilus --no-default-window\n"
    }
}

print OUTPUT "num_clients=$count\n";

if ($need_resume) {
    while (<SESSION>) {
	print OUTPUT;
    }
    close SESSION;
}
close OUTPUT;

if (!-d "$ENV{HOME}/.gnome/") {
    system ("mkdir -p $ENV{HOME}/.gnome");
}

system ("mv -f $outputf $ENV{HOME}/.gnome/session");
